Bug 1068716 - T540p middle click is not working on fedora 20
Summary: T540p middle click is not working on fedora 20
Keywords:
Status: CLOSED INSUFFICIENT_DATA
Alias: None
Product: Fedora
Classification: Fedora
Component: xorg-x11-drv-synaptics
Version: 20
Hardware: x86_64
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: Peter Hutterer
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-02-21 18:04 UTC by andrew
Modified: 2014-04-18 02:14 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-04-10 12:04:07 UTC


Attachments (Terms of Use)

Description andrew 2014-02-21 18:04:58 UTC
Description of problem:
On Lenovo T540p when trying to use the middle click button nothing happens.
This is a clean install of fedora 20. On a clean install of rhel6.5 this middle click works fine. 


Version-Release number of selected component (if applicable):


How reproducible:100%


Steps to Reproduce:
1. use 3 fingers on touch pad and click
2.
3.

Actual results: System will not middle click. 


Expected results: Middle click being registered and able to paste selected text.


Additional info:


[root@dhcp46-237 ~]# cat /etc/redhat-release 
Fedora release 20 (Heisenbug)
[root@dhcp46-237 ~]# uname -a
Linux 3.11.10-301.fc20.x86_64 #1 SMP Thu Dec 5 14:01:17 UTC 2013 x86_64 x86_64 x86_64 GNU/Linux

[root@dhcp46-237 ~]# rpm -qa | grep synaptics
xorg-x11-drv-synaptics-1.7.1-6.fc20.x86_64

Comment 1 Peter Hutterer 2014-03-24 06:13:22 UTC
are we talking about the middle click in the top area of the touchpad? one of the software-emulated buttons?

Comment 2 andrew 2014-03-26 22:30:57 UTC
(In reply to Peter Hutterer from comment #1)
> are we talking about the middle click in the top area of the touchpad? one
> of the software-emulated buttons?

Correct my work around was setting changing a entry in 50-synaptics.conf


/usr/share/X11/xorg.conf.d/50-synaptics.conf

Section "InputClass"

        Identifier "Default clickpad buttons"

        MatchDriver "synaptics"

        Option "SoftButtonAreas" "66% 0 0 50% 33% 65% 0 50%"

       Option "AreaTopEdge" "2621"

EndSection

Comment 3 Peter Hutterer 2014-03-26 23:53:07 UTC
Remove your snippet and give this one a try: https://admin.fedoraproject.org/updates/xorg-x11-drv-synaptics-1.7.4-4.fc20

Comment 4 John Priddy 2014-03-27 16:02:25 UTC
(In reply to Peter Hutterer from comment #3)
> Remove your snippet and give this one a try:
> https://admin.fedoraproject.org/updates/xorg-x11-drv-synaptics-1.7.4-4.fc20

I have a t440s and tried this package and it doesn't solve any of the issues from what I can tell -- with the default settings the middle mouse button and palm detection dont work, input frequently gets 'stuck' in a mouse button down state, etc, etc.  I think the pages you linked to/wrote better sum this up for people:

https://bugs.freedesktop.org/show_bug.cgi?id=74544

http://who-t.blogspot.com.au/2014/03/xorg-synaptics-support-for-lenovo-t440.html

Comment 5 andrew 2014-03-27 16:13:50 UTC
(In reply to John Priddy from comment #4)
> (In reply to Peter Hutterer from comment #3)
> > Remove your snippet and give this one a try:
> > https://admin.fedoraproject.org/updates/xorg-x11-drv-synaptics-1.7.4-4.fc20
> 
> I have a t440s and tried this package and it doesn't solve any of the issues
> from what I can tell -- with the default settings the middle mouse button
> and palm detection dont work, input frequently gets 'stuck' in a mouse
> button down state, etc, etc.  I think the pages you linked to/wrote better
> sum this up for people:
> 
> https://bugs.freedesktop.org/show_bug.cgi?id=74544
> 
> http://who-t.blogspot.com.au/2014/03/xorg-synaptics-support-for-lenovo-t440.
> html

Peter I will give that a try once my laptop is done being repaired. My motherboard was bricked.

Comment 6 Peter Hutterer 2014-03-27 22:34:52 UTC
John: you should get a middle mouse button in the top softbutton area in the middle by default. Palm detection is broken but we haven't had time to fix it yet. As for stuck input, make sure you pull libevdev from updates-testing.

Comment 7 Pasi Karkkainen 2014-04-03 13:43:41 UTC

I can confirm the middle-button issue with t440s. 

Earlier I was able to do a middle-click from the top softbutton area, but now with xorg-x11-drv-synaptics-1.7.4-4.fc20 it doesn't work anymore (although otherwise the touchpad is now better).

Comment 8 Ferry Huberts 2014-04-04 19:57:48 UTC
@Peter: the middle button is not working on my t440s

I'm running kernel 3.13.8-200.fc20.x86_64 but I think it already broke on 3.13.7-200.fc20.

Also, 'movement inhibition' stuff is 'less than stellar'; it makes my touchpad behave like it doesn't respond properly, please remove it.

I'd rather have the old responsive behaviour than how it is now.
In fact it's so bad, that I'm going back to a kernel that doesn't have this problem.

Comment 9 Ferry Huberts 2014-04-04 20:08:40 UTC
Ok it's not the kernel, my mistake.

I did a downgrade of xorg-x11-drv-synaptics to 1.7.1-5.fc20 and now at least I have the responsiveness back. Please _do_ try to run that driver yourself on a t440s to experience it, it's really bad (at least the default settings are). subtle touchpad movements are completely ignored (for example). also right in the middle of the touchpad, not just in the areas that are supposed to be button areas.

I still don't have a middle button, while this did work before.

Comment 10 Pasi Karkkainen 2014-04-06 10:37:51 UTC
Ok so with xorg-x11-drv-synaptics-1.7.4-5.fc20.x86_64 the middle-click seems to work again with t440s! Thanks.

Comment 11 John Blakeney 2014-04-07 03:29:20 UTC
(In reply to Ferry Huberts from comment #9)
> Ok it's not the kernel, my mistake.
> 
> I did a downgrade of xorg-x11-drv-synaptics to 1.7.1-5.fc20 and now at least
> I have the responsiveness back. Please _do_ try to run that driver yourself
> on a t440s to experience it, it's really bad (at least the default settings
> are). subtle touchpad movements are completely ignored (for example). also
> right in the middle of the touchpad, not just in the areas that are supposed
> to be button areas.
> 
> I still don't have a middle button, while this did work before.

I just experienced similar responsiveness issues on my ThinkPad T540p after upgrading to xorg-x11-drv-synaptics-1.7.4-5.fc20.x86_64.  Many of my attempts at moving the mouse cursor with the touchpad did not seem to register.  I also downgraded to 1.7.1-5, which restored the responsiveness for me.

I'm not sure if middle click would have worked for me with 1.7.4, but it hasn't worked on this machine with Fedora 20 with any previous version of the driver.

Please let me know if I can do anything else to help.

Comment 12 Hans de Goede 2014-04-10 12:04:07 UTC
Hi All,

Peter is on a short vacation and he has asked me to further help you with this bug.

I'm reading a number of issues intermixed in one bug here, which is quite hard to deal with. So I'm going to close this bug, and ask you all to file new bugs. Please don't take this the wrong way, I'm not claiming that you are not having issues. Nor am I saying that we don't care / are not going to fix your issues. It is just that having all these intermixed comments in one bug, about clearly different problems is very hard to deal with, hence I'm going to close this bug and I kindly ask you to file new bugs, with 1 issue per bug. Note that if you're suffering from multiple issues please file multiple bugs!

Before filing bugs, please retest with a clean config with the latest versions of all involved packages:

1) Undo any local configuration changes you've made, you can verify the standard files with:
"rpm --verify xorg-x11-drv-synaptics", and you can do a "yum reinstall xorg-x11-drv-synaptics" to restore them. If you've made changes outside of these files, or added new cfg files, please undo / remove these.

2) Make sure your xorg-x11-drv-synaptics is at version 1.7.4-5.fc20 or later. Note for 
L440 / Carbon X1 2nd edition owners, you need 1.7.4-6.fc20, which you can grab here:
http://koji.fedoraproject.org/koji/buildinfo?buildID=509915

3) Make sure you're running kernel >= 3.13.9, which is in f20-updates, and can also be found here:
http://koji.fedoraproject.org/koji/buildinfo?buildID=509098
See below why you need such a new kernel


With all of the above said, let me go through the different issues I've seen mentioned in this bug one by one:

1) Middle click in the top button area (the line of raised dots does not work):
This should work if you've the latest versions of packages as indicated above, if not please file a new bug.

2) Middle click using 3 finger click not working. I can confirm that this does not work on my T440s, I've filed bug 1086218 for tracking this. If you're interested in this add yourself to the CC,

3) An area of the touchpad no longer properly responding to finger moves. I believe the problem here is not the new behavior for the button area, but that the bottom button area is way too large. First let me explain the new behavior and then I'll get back to the way too large bit.

As some of you've already figured out this is intentional. Having touches which *start* inside the button area causing pointer moves often causes miss-clicks. Therefore we have disabled pointer movement inside the button area for touches which *start* inside the button area. If you start a touch outside of the button area and then move into the button area, that touch will keep causing pointer motion events. Note if you begin a little too low in the touchpad and then move out of the button area the touch will generate pointer motion events from then on. TL; DR: a touch which starts inside the button area will not generate pointer motion events as long as it stays inside the button area.

Note the above is how things should work. The reason why the above behavior is making many of you unhappy is because the bottom-button area is way too large. This is caused by the firmware in the touchpad reporting wrong min/max values for the x / y coordinates it gives us, and we take a percentage of the reported y-range determine where the bottom button area starts. We've recently written a kernel-patch which adds a quirk table for clickpads mis-reporting there min/max values which overrides what the firmware says and makes the kernel report the correct values. When running the kernel with this patch, the problems many of you have seen should go away. Which is why I ask you all to make sure that you're running a kernel >= 3.13.9 .


One last request, if you file a new bug please run the following 2 commands and copy and paste their output to the bug:
cat /sys/class/dmi/id/product_version
cat /sys/devices/pnp0/*/id

If your laptop is not one of: Helix, X240, T431s, T440s, T540p, please also do the following:

1) If you've experience with building code from source, please clone and build:
git://git.freedesktop.org/git/libevdev and then run sudo ./tools/touchpad-edge-detector /dev/input/eventX
To figure out the X above goto 2). and once you know the right event node run touchpad-edge-detector. Copy and paste the output into your new bug.

2) If you don't want to do 1 (which is slightly preferred) do:
sudo yum install evemu
Switch to a text console, do ctrl+alt+f2 and login there
sudo evemu
Notice which event-node is the touchpad and do:
sudo evemu /dev/input/eventX > evemu.log
Then move your finger along the edge of your touchpad (all 4 sides) and after that do ctrl+c. Attach the generated evemu.log file to your new bug.


Last let me thank you all for your input, your input, and the information you provide are very much appreciated and with it we should soon be able to make this all work well out of the box.

Regards,

Hans

Comment 13 Ferry Huberts 2014-04-10 14:25:51 UTC
That is an awesome reply on this bug report!
Respect.

I've ran with it and tested it (for the last 5minutes :-) )
It seems _much_ improved: middle click works, responsiveness is back.
I'm happy!

thanks Hans!

Comment 14 John Blakeney 2014-04-11 00:51:56 UTC
I upgraded my kernel and synaptics driver as recommended, and issues (1) and (3) are now resolved on my T540p.  Issue (2) still affects me, as I commented on the other bug.  Thank you, Hans!

Comment 15 Hans de Goede 2014-04-17 12:19:53 UTC
Hi all,

I would like to have one bit more info from your systems for future reference, can you please do:

dmesg | grep synaptics

And leave a message with your ThinkPad model + the output here ?

Thanks & Regards,

Hans

Comment 16 John Blakeney 2014-04-18 02:14:25 UTC
Here's the output of dmesg | grep synaptics on my T540p:

[    1.778565] psmouse serio1: synaptics: Touchpad model: 1, fw: 8.1, id: 0x1e2b1, caps: 0xd001a3/0x940300/0x127c00, board id: 2722, fw id: 1484859
[    1.778569] psmouse serio1: synaptics: serio: Synaptics pass-through port at isa0060/serio1/input0


Note You need to log in before you can comment on or make changes to this bug.